/* 
 * PDFlib PLOP:
 * Demonstrate digital signature features with optional signature visualization
 */

import java.io.*;
import com.pdflib.plop;
import com.pdflib.PLOPException;

public class sign
{
    public static void main (String argv[])
    {
	plop plop = null;

	/* Basic signature options */
	String sign_opts =
	    "ltv=try " +         /* use ltv=full to ensure LTV status */
	    /* for use with PKCS11
	    "engine=pkcs#11 digitalid={filename=cryptoki.dll} "
	    */
	    "engine=builtin digitalid={filename=demo_signer_rsa_2048.p12} password={demo} ";

	try {
	    /* parameters for the input document */
	    String optlist;
	    String fieldoptlist = "";
	    String searchpath = "../data";

	    int doc;
	    int visdoc =-1;
	    boolean visualize = false;
	    String visfile = "signing_man_pdfa1a.pdf";

	    if (argv.length < 2) {
		throw new Exception("usage: sign  <filename> <outfilename>");
	    }

	    plop = new plop();

	    /* open unprotected input file without any password */
	    optlist = "searchpath {" + searchpath + "} ";
	    plop.set_option(optlist);
	    if ((doc = plop.open_document(argv[0], "")) == -1) {
		throw new Exception("Error: " + plop.get_apiname()
		                        + ": " + plop.get_errmsg());
	    }
	    optlist = sign_opts;

	    if (visualize) {
		if ((visdoc = plop.open_document(visfile, "")) == -1) {
		    throw new Exception("Error: " + plop.get_apiname()
					    + ": " + plop.get_errmsg());
		}
		fieldoptlist = "field={visdoc=" + visdoc + " rect={50 50 adapt adapt}} ";
		optlist = optlist + fieldoptlist;
	    }

	    if (plop.prepare_signature(optlist) == -1) {
	        throw new Exception("Error: " + plop.get_apiname()
                                        + ": " + plop.get_errmsg());
	    }

	    if (plop.create_document(argv[1], "input=" + doc) == -1) {
	        throw new Exception("Error: " + plop.get_apiname()
                                        + ": " + plop.get_errmsg());
	    }

	    /* close input and output files */
	    plop.close_document(doc, "");
	    if (visualize) {
		plop.close_document(visdoc, "");
	    }

        } catch (PLOPException e) {
            System.err.println("PLOP exception occurred in sign sample:");
            System.err.println("[" + e.get_errnum() + "] " + e.get_apiname() +
                            ": " + e.get_errmsg());
        } catch (Exception e) {
            System.err.println(e);
	} finally {
	    /* delete the PLOP object */
	    if (plop != null) plop.delete();
	}
    }
}
